package me.totalfreedom.totalfreedommod.rank;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.JoinConfiguration;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.text.serializer.legacy.LegacyComponentSerializer;
import net.md_5.bungee.api.ChatColor;

public interface Displayable
{

    String getArticle();

    String getName();

    String getTag();

    String getAbbr();

    String getPlural();

    ChatColor getColor();

    org.bukkit.ChatColor getTeamColor();

    String getColoredName();

    Component getColoredTag();

    String getColoredLoginMessage();

    boolean hasTeam();

    boolean hasDefaultLoginMessage();

    default Component generateColoredTag(String colorAndTag)
    {
        Component open = Component.text("[").color(NamedTextColor.DARK_GRAY);
        Component close = Component.text("]").color(NamedTextColor.DARK_GRAY);
        Component tagComponent = LegacyComponentSerializer.legacyAmpersand().deserialize(colorAndTag);
        return Component.join(JoinConfiguration
                .builder()
                .separator(Component.text(" "))
                .build(), open, tagComponent, close);
    }

}